#include "stdafx.h"
#include "nesCE.h"
#include <commctrl.h>
#include <aygshell.h>
#include <sipapi.h>
#include "fceu\\m6502.h"
#include "fceu\\svga.h"
#include "keyscan.h"


//E-125 keycodes (taken from MameCE and modified a little for E-125)
#define VK_CASSIOPEIA_SLIDER	0x86
#define VK_CASSIOPEIA_ESC		0xC1
#define VK_CASSIOPEIA_REC		0xC2
#define VK_CASSIOPEIA_B1		0xC3
#define VK_CASSIOPEIA_B2		0xC4
#define VK_CASSIOPEIA_B3		0xC5
#define VK_CASSIOPEIA_LEFT		37
#define VK_CASSIOPEIA_UP		38
#define VK_CASSIOPEIA_RIGHT		39
#define VK_CASSIOPEIA_DOWN		40

//E-10X keycodes
//#define VK_CASSIOPEIA_SLIDER	0x86
//#define VK_CASSIOPEIA_ESC		0xC1
//#define VK_CASSIOPEIA_REC		0x86
//#define VK_CASSIOPEIA_B1		0xC2
//#define VK_CASSIOPEIA_B2		0xC3
//#define VK_CASSIOPEIA_B3		0xC4

unsigned short color_palette[256];

// this is set to 1 when it is time to stop the sound output (so we can have a 
// seperate thread just doing sound eventually).
static int SoundExit = 0;

char KeyboardBuffer[256];

// handle to the main window
HWND hWndNES;

void PrintFatalError(char *s)
{
	int i;

	TCHAR szError[256];

	for(i = 0; s[i] != 0; i++)
		szError[i] = (TCHAR)s[i];

	szError[i] = 0;

	MessageBox(NULL, szError, _T("Fatal Error"), MB_ICONERROR | MB_OK | MB_SETFOREGROUND | MB_TOPMOST);
}

void PrintNonFatal(char *s)
{
	int i;

	TCHAR szError[256];

	for(i = 0; s[i] != 0; i++)
		szError[i] = (TCHAR)s[i];

	szError[i] = 0;

	MessageBox(NULL, szError, _T("Non-Fatal Error"), MB_OK | MB_SETFOREGROUND | MB_TOPMOST);
}

//------------------------------------------------------------------------------------
// we use a 16 bit color palette (rrrrrggggggbbbbb). This should change based
// on the device, but for now I just wanted something quick to try to get it working
// on the E-125.
//------------------------------------------------------------------------------------
void SetPalette(unsigned char index, unsigned char r, unsigned char g, unsigned char b)
{
	color_palette[index] = (((unsigned short)r << 8) & 0xf800) | 
		(((unsigned short)g << 3) & 0x0fe0) | 
		((unsigned short)b >> 3);
}

//------------------------------------------------------------------------------
// the following function is only used when we save a screen snapshot to a file
//------------------------------------------------------------------------------
void GetPalette(unsigned char i, unsigned char *r, unsigned char *g,unsigned char *b)
{
	*r = (unsigned char)((color_palette[i] >> 8) & 0xf8);
	*g = (unsigned char)((color_palette[i] >> 3) & 0xfc);
	*b = (unsigned char)((color_palette[i] << 3) & 0xf8);
}

void NetworkClose(void)
{
}

// wait for vertical blank to slow down emulation speed (like we really need this for
// windows ce...)
void WaitForVBlank(void)
{

}


// this function restores the video mode to normal. Happens when program exiting.
void ResetVideo(void)
{

}


// initialize the keyboard (buttons) on program start
int KeyboardInitialize(void)
{
	int i;

	for(i = 0; i < 256; i++)
		KeyboardBuffer[i] = 0;

	// return 1 for success, 0 for failure
	return 1;
}

// release the keyboard (buttons on windows ce) when program exits.
void KeyboardClose(void)
{

}


// set the video mode to vmode (we may support 2 modes here for windows ce - 
// one normal, and one rotated 90 degrees).
int SetVideoMode(int vmode)
{

	// return 1 for success, 0 for failure
	return 1;
}

// initialize sound. Return 0 for no sound, otherwise return the rate.
int InitSound(void)
{
	
	return 0;
}

void TrashSound(void)
{
	// signal the sound thread to stop
	SoundExit = 1;
}


// called before the emulation machine is initialized
int PreInit(void)
{
	return 1;
}




// initialize the joystick.
char InitJoystick(void)
{
	return 0;
}

// read the joystick
unsigned long GetJSOr(void)
{
	return 0;
}

// release joystick on exit
void KillJoystick(void)
{
}


//----------------------------------------------------------------------------------
// KeyboardGetState reads the state of the buttons, and writes it to the char
// array KeyboardBuffer. KeyboardBuffer is large enough to support 256 keys. If 
// a key is pressed, the cooresponding byte is set to 0x80. If it is not pressed, 
// the byte is set to 0x00 in the array. See Keyscan.h for constant indexes to use.
//----------------------------------------------------------------------------------
char *KeyboardGetstate(void)
{
	
	KeyboardBuffer[SCANCODE_CURSORUP] = GetAsyncKeyState(VK_CASSIOPEIA_UP);
	KeyboardBuffer[SCANCODE_CURSORDOWN] = GetAsyncKeyState(VK_CASSIOPEIA_DOWN);
	KeyboardBuffer[SCANCODE_CURSORLEFT] = GetAsyncKeyState(VK_CASSIOPEIA_LEFT);
	KeyboardBuffer[SCANCODE_CURSORRIGHT] = GetAsyncKeyState(VK_CASSIOPEIA_RIGHT);
	KeyboardBuffer[SCANCODE_LEFTALT] = GetAsyncKeyState(VK_CASSIOPEIA_B1);
	KeyboardBuffer[SCANCODE_LEFTCONTROL] = GetAsyncKeyState(VK_CASSIOPEIA_B2);
	KeyboardBuffer[SCANCODE_TAB] = GetAsyncKeyState(VK_CASSIOPEIA_B3);
	KeyboardBuffer[SCANCODE_ENTER] = GetAsyncKeyState(VK_CASSIOPEIA_SLIDER);
	KeyboardBuffer[SCANCODE_ESCAPE] = GetAsyncKeyState(VK_CASSIOPEIA_ESC);
			
	return KeyboardBuffer;
}

int KeyboardUpdate(void)
{
	return 1;
}


