#define INITGUID
#include <stdio.h>
#include <windows.h>
#include <windowsx.h>
#include <winsock.h>
#include <mmsystem.h>
#include <directx.h>
//#include <ddraw.h>
//#include <dinput.h>
//#include <dsound.h>
#include "../../m6502.h"
#include "../../svga.h"
#include "../../fce.h"
#include "../../config.h"
#include "../../general.h"
#include "../../version.h"


#define szWndClassName "FCEUCLASS"



static int WindowDead=0;

void PrintFatalError(char *s)
{
	ShowCursor(1);
	MessageBox(0,s,"Fatal Error",MB_ICONERROR|MB_OK|MB_SETFOREGROUND|MB_TOPMOST);
	ShowCursor(0);
}

void printNonFatal(char *str)
{
	ShowCursor(1);
	MessageBox(0,str,"Non-Fatal Error",MB_ICONWARNING|MB_OK|MB_SETFOREGROUND|MB_TOPMOST);
	ShowCursor(0);
}



HANDLE ThreadHandle;
HWND hAppWnd=0;
HWND hParent;
HINSTANCE hin;

LPDIRECTDRAWSURFACE4  lpDDSPrimary;  // DirectDraw primary surface
LRESULT FAR PASCAL AppWndProc(HWND,UINT,WPARAM,LPARAM);

LPDIRECTDRAWPALETTE lpddpal=NULL;
PALETTEENTRY color_palette[256];     // Palette "buffer"

LPDIRECTDRAW  lpDD;
LPDIRECTDRAW4 lpDD4=0;

DDSURFACEDESC2 ddsd;
HRESULT  ddrval;



DDSURFACEDESC2        ddsdback;
LPDIRECTDRAWSURFACE4  lpDDSBack;  // DirectDraw primary surface

static int vflags;
static int veflags=0;


static int fixthreadpri=0;
LRESULT FAR PASCAL AppWndProc(HWND hWnd,UINT msg,WPARAM wParam,LPARAM lParam) { 
	// this is where we receive all message concerning this window
	// we can either process a message or pass it on to the default
	// message handler of windows
	switch(msg) {
    case WM_KEYDOWN:
		switch( wParam ) {
        case VK_ESCAPE:
        case VK_F12:
			// Close window if Esc or F12 was pressed
			Exit=1;
			SetThreadPriority(hin,THREAD_PRIORITY_NORMAL);   
			break;
		}
		break;
		case WM_DESTROY:
			WindowDead=1;
			PostQuitMessage(0);  // Terminate Application
			break;
		case WM_ACTIVATE:
			switch(wParam&0xFFFF)
			{
			case WA_INACTIVE:
				if(!Exit) fixthreadpri=-1;
				else fixthreadpri=1;
				WindowDead=1;
				if(soundon)SetThreadPriority(ThreadHandle,THREAD_PRIORITY_IDLE);
				break;
			case WA_ACTIVE:fixthreadpri=1;
				WindowDead=0;if(soundon)SetThreadPriority(ThreadHandle,THREAD_PRIORITY_ABOVE_NORMAL);
				break;
			}
			default:
				// We didn't process the message so let Windows do it
				return DefWindowProc(hWnd,msg,wParam,lParam);
	}
	// We processed the message and there
	// is no processing by Windows necessary
	return 0L;
}

static int PaletteChanged=0;

static int MainWindowX=1,MainWindowY=1;
void HideMainWindow(void)
{
	SetWindowPos(hAppWnd,HWND_TOP,0,0,MainWindowX,MainWindowY,SWP_HIDEWINDOW);
	
}

void ShowMainWindow(void)
{
	SetWindowPos(hAppWnd,HWND_TOP,0,0,MainWindowX,MainWindowY,SWP_SHOWWINDOW);
}

void SetPalette(unsigned char index, unsigned char r, unsigned char g, unsigned char b)
{
	color_palette[index].peRed=r;
	color_palette[index].peGreen=g;
	color_palette[index].peBlue=b;
	PaletteChanged=1;
}

void GetPalette(unsigned char i, unsigned char *r, unsigned char *g,unsigned char *b)
{
	*r=color_palette[i].peRed;
	*g=color_palette[i].peGreen;
	*b=color_palette[i].peBlue;
}

LPDIRECTINPUT lpDI;
WINDOWPLACEMENT ParentPlacement;

static char *oogv[64];
static int argco;


static char gfsdir[1024];


void GetBaseDirectory(char *bd, char *f)
{
	int x;
	bd[0]=0;
	GetModuleFileName(0,(LPTSTR)bd,2047);
	
	for(x=strlen(bd);x>=0;x--)
	{
		if(bd[x]=='\\' || bd[x]=='/')
		{bd[x]=0;break;}
	}
}

byte honk;
static char fbuffer[1024];

GUID joyGUID[4];
static int joyF[4];
BOOL CALLBACK JoystickSearch(LPCDIDEVICEINSTANCE lpddi, LPVOID pvRef)
{
	SendDlgItemMessage(pvRef,1126,CB_ADDSTRING,0,(LPARAM)(LPSTR)lpddi->tszProductName);
	SendDlgItemMessage(pvRef,1127,CB_ADDSTRING,0,(LPARAM)(LPSTR)lpddi->tszProductName);
	SendDlgItemMessage(pvRef,1131,CB_ADDSTRING,0,(LPARAM)(LPSTR)lpddi->tszProductName);
	SendDlgItemMessage(pvRef,1132,CB_ADDSTRING,0,(LPARAM)(LPSTR)lpddi->tszProductName);
	
	return DIENUM_CONTINUE;
}


static byte temp[1024];
static int  gork;

UINT APIENTRY OFNHookProc(HWND hdlg, UINT uiMsg, WPARAM wParam, LPARAM lParam)
{
	switch(uiMsg)
	{
	case WM_INITDIALOG:
		CheckDlgButton(hdlg,1121,dowait?BST_UNCHECKED:BST_CHECKED);
		CheckDlgButton(hdlg,1122,ssync?BST_CHECKED:BST_UNCHECKED);
		CheckDlgButton(hdlg,1125,soundon?BST_CHECKED:BST_UNCHECKED);
		CheckDlgButton(hdlg,1123,ntsccol?BST_CHECKED:BST_UNCHECKED);
		
		SendDlgItemMessage(hdlg,1120,CB_ADDSTRING,0,(LPARAM)(LPSTR)"320x240 Full Screen");
		SendDlgItemMessage(hdlg,1120,CB_ADDSTRING,0,(LPARAM)(LPSTR)"512x384 Centered");
		SendDlgItemMessage(hdlg,1120,CB_ADDSTRING,0,(LPARAM)(LPSTR)"640x480 Centered");
		SendDlgItemMessage(hdlg,1120,CB_ADDSTRING,0,(LPARAM)(LPSTR)"640x480 Scanlines");
		SendDlgItemMessage(hdlg,1120,CB_ADDSTRING,0,(LPARAM)(LPSTR)"640x480 TV Simulation");
		SendDlgItemMessage(hdlg,1120,CB_ADDSTRING,0,(LPARAM)(LPSTR)"640x480 (scaled: 2x,2y)");
		SendDlgItemMessage(hdlg,1120,CB_ADDSTRING,0,(LPARAM)(LPSTR)"1024x768 (scaled: 4x,3y)");
		SendDlgItemMessage(hdlg,1120,CB_ADDSTRING,0,(LPARAM)(LPSTR)"1280x1024 (scaled: 5x,4y)");
		SendDlgItemMessage(hdlg,1120,CB_ADDSTRING,0,(LPARAM)(LPSTR)"1600x1200 (scaled: 6x,5y)");
		SendDlgItemMessage(hdlg,1120,CB_SETCURSEL,vmode-1,(LPARAM)(LPSTR)0);
		
		SendDlgItemMessage(hdlg,1126,CB_ADDSTRING,0,(LPARAM)(LPSTR)"<none>");
		SendDlgItemMessage(hdlg,1127,CB_ADDSTRING,0,(LPARAM)(LPSTR)"<none>");
		
		SendDlgItemMessage(hdlg,1131,CB_ADDSTRING,0,(LPARAM)(LPSTR)"<none>");
		SendDlgItemMessage(hdlg,1132,CB_ADDSTRING,0,(LPARAM)(LPSTR)"<none>");
		
		IDirectInput_EnumDevices(lpDI, DIDEVTYPE_JOYSTICK,JoystickSearch,hdlg,DIEDFL_ATTACHEDONLY);
		SendDlgItemMessage(hdlg,1126,CB_SETCURSEL,joy[0],(LPARAM)(LPSTR)0);
		SendDlgItemMessage(hdlg,1127,CB_SETCURSEL,joy[1],(LPARAM)(LPSTR)0);
		SendDlgItemMessage(hdlg,1131,CB_SETCURSEL,joy[2],(LPARAM)(LPSTR)0);
		SendDlgItemMessage(hdlg,1132,CB_SETCURSEL,joy[3],(LPARAM)(LPSTR)0);
		break;
	case 273:
		{char bualf[256];
		GetCurrentDirectory(256,bualf);
		switch(wParam)
		{
		case 1121:dowait^=1;break;
		case 1122:ssync^=1;break; 
		case 1124:PAL^=1;break;                    
		case 1123:ntsccol^=1;     
			break;
		case 1125:soundon^=1;      
			break;
		case 1128:genie^=3;break;                    
		}
        }
		break;
	case WM_NOTIFY:
		if(((OFNOTIFY *)lParam)->hdr.code==CDN_FILEOK)
		{
			int zap;
			zap=SendDlgItemMessage(hdlg,1120,CB_GETCURSEL,0,(LPARAM)(LPSTR)0);
			if(zap!=CB_ERR) vmode=zap+1;
			
			zap=SendDlgItemMessage(hdlg,1126,CB_GETCURSEL,0,(LPARAM)(LPSTR)0);
			if(zap!=CB_ERR) joy[0]=zap;
			
			zap=SendDlgItemMessage(hdlg,1127,CB_GETCURSEL,0,(LPARAM)(LPSTR)0);
			if(zap!=CB_ERR) joy[1]=zap;
			
			zap=SendDlgItemMessage(hdlg,1131,CB_GETCURSEL,0,(LPARAM)(LPSTR)0);
			if(zap!=CB_ERR) joy[2]=zap;
			
			zap=SendDlgItemMessage(hdlg,1132,CB_GETCURSEL,0,(LPARAM)(LPSTR)0);
			if(zap!=CB_ERR) joy[3]=zap;
			
			
			if(GetDlgItemText(hdlg,1129,(LPTSTR)temp,1024))
				gork=-2;
			else
			{
				zap=0;
				gork=GetDlgItemInt(hdlg,1130,(BOOL *)&zap,0);
				if(!zap)
					gork=-1;
			}
		}
		break;
	}
	return 0;
}


char *GetDriverConfig(void)
{
	return gfsdir;
}
char *SetDriverConfig(void)
{
	gfsdir[0]=0;
	return gfsdir;
}

void GetFileSelect(void)
{
	const char filter[]="All usable files(*.nes,*.nsf,*.fds)\0*.nes;*.nsf;*.fds\0All files (*.*)\0*.*\0";
	OPENFILENAME ofn;
	memset(&ofn,0,sizeof(ofn));
	ofn.lStructSize=sizeof(ofn);
	ofn.hInstance=hin;
	ofn.lpstrTitle="FCE Ultra Open File...";
	ofn.lpstrFilter=filter;
	ofn.lpstrFile=fbuffer;
	ofn.nMaxFile=256;
	ofn.lpfnHook=OFNHookProc;
	ofn.Flags=OFN_EXPLORER|OFN_ENABLETEMPLATE|OFN_ENABLEHOOK;
	ofn.lpTemplateName=MAKEINTRESOURCE(100);
	if(gfsdir[0]) ofn.lpstrInitialDir=gfsdir;
	
	if(GetOpenFileName(&ofn))
	{
		if(PAL) oogv[argco++]="-pal";
		if(gork==-2)          // Connect to server
		{
			oogv[argco++]="-connect";
			oogv[argco++]=temp;
		}
		else if(gork>=0)      // We're server.
		{
			static char num[8];
			sprintf(num,"%d",gork);
			oogv[argco++]="-server";
			oogv[argco++]=num;
		}
		oogv[argco++]=fbuffer;
		strncpy(gfsdir,ofn.lpstrFile,ofn.nFileOffset);
		gfsdir[ofn.nFileOffset]=0;
	}
}


//int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,LPSTR lpCmdLine, int nCmdShow)

int main(int argc,char *argv[])
{
	
	int x;
	
	hin=GetModuleHandle(0);
	createwin();
	ShowMainWindow();
	ddrval=DirectInputCreate(hin,DIRECTINPUT_VERSION,&lpDI,0);
	
	if(ddrval!=DI_OK)
	{
		PrintFatalError("DirectInput: Error creating DirectInput object.");
		return 0;
	}
	HideMainWindow();
	
	argco=argc;
	if(argco>64) argco=64;
	memcpy(oogv,argv,argco*sizeof(char*));
	
	GetBaseDirectory(temp, 0);
	sprintf(TempArray,"%s%s"PSS"fceu.cfg",temp,BaseDirectory);
	LoadConfig(TempArray);
	
	if(argco==1)
		GetFileSelect();
	
	HideMainWindow();
	
	{
		int z;
		z=fceumain(argco,oogv);
		DestroyWindow(hAppWnd);
		return z;
	}
}


int createwin(void)
{
	WNDCLASSEX winclass;
	
	winclass.cbSize=sizeof(WNDCLASSEX);
	winclass.style=CS_OWNDC|CS_HREDRAW|CS_VREDRAW;
	winclass.lpfnWndProc=AppWndProc;
	winclass.cbClsExtra=0;
	winclass.cbWndExtra=0;
	winclass.hInstance=hin;
	winclass.hIcon=LoadIcon(NULL, IDI_APPLICATION);
	winclass.hIconSm=LoadIcon(NULL,IDI_APPLICATION);
	winclass.hCursor=LoadCursor(NULL, IDC_ARROW);
	winclass.hbrBackground=GetStockObject(BLACK_BRUSH);
	winclass.lpszMenuName=NULL;
	winclass.lpszClassName=szWndClassName;
	
	if(!RegisterClassEx(&winclass))
		return FALSE;
	
	// Create our Main Application Window
	hAppWnd = CreateWindowEx(0,szWndClassName,"FCE Ultra",  // Class Name and Window Title
		WS_POPUP,          // Style of Window
		0,0,1,1,  // Position and Size of Window
		NULL,NULL,hin,  // Handle of Parent Window, Menu and Instance
		NULL );  
	
	HideMainWindow();
	return 1;
}

int PreInit(void)
{
	return 1;
}
static byte vmod;


int RestoreDD(int w)
{
	if(w)
	{if(IDirectDrawSurface4_Restore(lpDDSBack)!=DD_OK) return 0;}
	else
	{if(IDirectDrawSurface4_Restore(lpDDSPrimary)!=DD_OK) return 0;}
	veflags|=1;
	return 1;
}

int BlockingCheck(void)
{
	MSG msg;
	
	while( PeekMessage( &msg, 0, 0, 0, PM_NOREMOVE ) )
	{
		if( GetMessage( &msg, 0,  0, 0)>0 )
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}
	return Exit;
}


void BlitScreen(void)
{
	
	static int pitch;
	extern byte *XBuf;
	unsigned char *XBaf;
	char *ScreenLoc;
	unsigned long x;
	byte y;
	
	XBaf=XBuf;
	
msgloop:
	if(BlockingCheck()) return;
	if(fixthreadpri)
	{
		if(fixthreadpri==-1)
			SetThreadPriority(hin,THREAD_PRIORITY_IDLE);
		else
			SetThreadPriority(hin,THREAD_PRIORITY_NORMAL);   
		fixthreadpri=0;
		goto msgloop;
	}
	if(WindowDead) goto msgloop;
	
	if(PaletteChanged==1)
	{
		ddrval=IDirectDrawPalette_SetEntries(lpddpal,0,0,256,color_palette);
		if(ddrval!=DD_OK)
		{
			if(ddrval==DDERR_SURFACELOST) RestoreDD(0);
			return;
		}
		PaletteChanged=0;
	}
	
	
	if(vflags&1)
	{
		ddrval=IDirectDrawSurface4_Lock(lpDDSBack,NULL,&ddsdback, 0, NULL);
		
		if(ddrval!=DD_OK)
		{
			if(ddrval==DDERR_SURFACELOST) RestoreDD(1);
			return;
		}
		
		ScreenLoc=ddsdback.lpSurface;
		pitch=ddsdback.DUMMYUNIONNAMEN(1).lPitch;
		
	}
	
	else
	{
		ddrval=IDirectDrawSurface4_Lock(lpDDSPrimary,NULL,&ddsd, 0, NULL);
		
		if(ddrval!=DD_OK)
		{
			if(ddrval==DDERR_SURFACELOST) RestoreDD(0);
			return;
		}
		
		ScreenLoc=ddsd.lpSurface;
		pitch=ddsd.DUMMYUNIONNAMEN(1).lPitch;
	}
	
	
	if(veflags&1)
	{
		switch(vmod)
		{
		default: memset((char *)ScreenLoc,0x80,pitch*240);break;
		case 2: memset((char *)ScreenLoc,0x80,pitch*384);break;
		case 3:
		case 4:
		case 5:
			
		case 9: veflags|=2;
		case 6: if(vflags&1) {veflags|=2;memset((char *)ScreenLoc,0x80,pitch*240);}
			else memset((char *)ScreenLoc,0x80,pitch*480);
			break;
		case 8:
		case 7: veflags|=2;memset((char *)ScreenLoc,0x80,pitch*256);break;
		}
		PaletteChanged=1;
		veflags&=~1;
	}
	
	
	
	if(vmod==5)
	{
		asm volatile(
			"xorl %%edx, %%edx\n\t"
			"koop1:\n\t"
			"movb $128,%%al     \n\t"
			"koop2:\n\t"
			"movb 1(%%esi),%%dl\n\t"
			"shl  $16,%%edx\n\t"
			"movb (%%esi),%%dl\n\t"
			"orl $0x80008000,%%edx\n\t"
			"movl %%edx,(%%edi)\n\t"
			"addl $2,%%esi\n\t"
			"addl $4,%%edi\n\t"
			"decb %%al\n\t"
			"jne koop2\n\t"
			
			"addl $16,%%esi\n\t"
			"addl %%ecx,%%edi\n\t"
			"decb %%bl\n\t"
			"jne koop1\n\t"
			:
		: "S" (XBuf), "D" (ScreenLoc+((240-maxline)/2)*pitch+(640-512)/2), "b" (maxline), "c" (pitch-512+pitch)
			: "%al", "%edx", "%cc" );
		
	}
	else if(vmod==4)
	{
		asm volatile(
			"yoop1:\n\t"
			"movb $128,%%al     \n\t"
			"yoop2:\n\t"
			"movb 1(%%esi),%%dh\n\t"
			"movb %%dh,%%dl\n\t"
			"shl  $16,%%edx\n\t"
			"movb (%%esi),%%dl\n\t"
			"movb %%dl,%%dh\n\t"               // Ugh
			"movl %%edx,(%%edi)\n\t"
			"addl $2,%%esi\n\t"
			"addl $4,%%edi\n\t"
			"decb %%al\n\t"
			"jne yoop2\n\t"
			
			"addl $16,%%esi\n\t"
			"addl %%ecx,%%edi\n\t"
			"decb %%bl\n\t"
			"jne yoop1\n\t"
			:
		: "S" (XBuf), "D" (ScreenLoc+((240-maxline)/2)*pitch+(640-512)/2), "b" (maxline), "c" (pitch-512+pitch)
			: "%al", "%edx", "%cc" );
	}
	else if(vmod==6 && !(vflags&1))
	{
		asm volatile(
			"yyoop1:\n\t"
			"movb $128,%%al     \n\t"
			"yyoop2:\n\t"
			"movb 1(%%esi),%%dh\n\t"
			"movb %%dh,%%dl\n\t"
			"shl  $16,%%edx\n\t"
			"movb (%%esi),%%dl\n\t"
			"movb %%dl,%%dh\n\t"               // Ugh
			"movl %%edx,(%%edi)\n\t"
			"movl %%edx,640(%%edi)\n\t"
			"addl $2,%%esi\n\t"
			"addl $4,%%edi\n\t"
			"decb %%al\n\t"
			"jne yyoop2\n\t"
			
			"addl $16,%%esi\n\t"
			"addl %%ecx,%%edi\n\t"
			"decb %%bl\n\t"
			"jne yyoop1\n\t"
			:
		: "S" (XBuf), "D" (ScreenLoc+((240-maxline)/2)*pitch+(640-512)/2), "b" (maxline), "c" (pitch-512+ddsd.DUMMYUNIONNAMEN(1).lPitch)
			: "%al", "%edx", "%cc" );
	}
	
	else switch(vmod)
	{
  case 9:
	  ScreenLoc += ((240-maxline)>>1)*pitch;  
	  for(y=0;y<maxline;y++)
	  {
		  for(x=0;x<64;x++)
		  {
			  *(long *)ScreenLoc=*(long *)XBaf;
			  ScreenLoc+=4;
			  XBaf+=4;
		  }
		  ScreenLoc+=pitch-256;
		  XBaf+=16;
	  }
	  break;
	  
  case 8:
  case 7:
	  ScreenLoc += ((240-maxline)>>1)*pitch+(pitch<<3);  
	  for(y=0;y<maxline;y++)
	  {
		  for(x=0;x<64;x++)
		  {
			  *(long *)ScreenLoc=*(long *)XBaf;
			  ScreenLoc+=4;
			  XBaf+=4;
		  }
		  ScreenLoc+=pitch-256;
		  XBaf+=16;
	  }
	  break;
	  
  case 6:
  case 1:
	  ScreenLoc += ((240-maxline)>>1)*pitch+32;  
	  for(y=0;y<maxline;y++)
	  {
		  for(x=0;x<64;x++)
		  {
			  *(long *)ScreenLoc=*(long *)XBaf;
			  ScreenLoc+=4;
			  XBaf+=4;
		  }
		  ScreenLoc+=pitch-256;
		  XBaf+=16;
	  }
	  break;
	  
  case 2:
	  ScreenLoc += ((384-maxline)>>1)*pitch+128;  
	  for(y=0;y<maxline;y++)
	  {
		  for(x=0;x<64;x++)
		  {
			  *(long *)ScreenLoc=*(long *)XBaf;
			  ScreenLoc+=4;
			  XBaf+=4;
		  }
		  ScreenLoc+=pitch-256;
		  XBaf+=16;
	  }
	  break;
	  
	  
  case 3:
	  ScreenLoc += ((640-256)>>1)+ ((480-maxline)>>1)*pitch;
	  for(y=0;y<maxline;y++)
	  {
		  for(x=0;x<64;x++)
		  {
			  *(long *)ScreenLoc=*(long *)XBaf;
			  ScreenLoc+=4;
			  XBaf+=4;
		  }
		  ScreenLoc+=pitch-256;
		  XBaf+=16;
	  }
	  break;
	}
	if(vflags&1)
	{
		RECT drect,srect;
		
		drect.left=0;
		drect.right=MainWindowX;
		drect.top=0;
		drect.bottom=MainWindowY;
		
		if(vmod==9)
		{drect.left=32;drect.right=1568;}
		
		srect.left=0;
		if(vmod==7 || vmod==8 || vmod==9)
			srect.right=256;
		else
			srect.right=320;
		
		srect.top=0;
		if(vmod==7 || vmod==8)
			srect.bottom=256;
		else
			srect.bottom=240;
		
		IDirectDrawSurface4_Unlock(lpDDSBack, NULL);
		
		if(veflags&2)
		{
			if(IDirectDrawSurface4_Lock(lpDDSPrimary,NULL,&ddsd, 0, NULL)==DD_OK)
			{
				memset(ddsd.lpSurface,0x80,ddsd.DUMMYUNIONNAMEN(1).lPitch*MainWindowY);
				IDirectDrawSurface4_Unlock(lpDDSPrimary, NULL);
				veflags&=~2;
			}
		}
		
		ddrval=IDirectDrawSurface4_Blt(lpDDSPrimary, &drect,lpDDSBack,&srect,DDBLT_WAIT,0);
		if(ddrval!=DD_OK)
		{
			if(ddrval==DDERR_SURFACELOST)
			{
				RestoreDD(0);
				RestoreDD(1);
			}
			return;
		}
	}
	else
		IDirectDrawSurface4_Unlock(lpDDSPrimary, NULL);
}

int SetVideoMode(int vmode)
{
	DDCAPS caps;
	
	vflags=0;
	ddrval = DirectDrawCreate ( NULL, &lpDD, NULL);
	if (ddrval != DD_OK)
	{
		PrintFatalError("DirectDraw: Error creating DirectDraw object.");
		return 0;
	}
	
	ddrval = IDirectDraw_SetCooperativeLevel ( lpDD, hAppWnd, DDSCL_EXCLUSIVE | DDSCL_FULLSCREEN | DDSCL_ALLOWREBOOT);
	if (ddrval != DD_OK)
	{
		PrintFatalError("DirectDraw: Error setting cooperative level.");
		return 0;
	}
	
	ddrval = IDirectDraw_QueryInterface(lpDD,&IID_IDirectDraw4,(LPVOID *)&lpDD4);
	if (ddrval != DD_OK)
	{
		PrintFatalError("DirectDraw: Error querying interface.");
		return 0;
	}
	
	ddrval = IDirectDraw4_SetCooperativeLevel ( lpDD4, hAppWnd, DDSCL_EXCLUSIVE | DDSCL_FULLSCREEN | DDSCL_ALLOWREBOOT);
	if (ddrval != DD_OK)
	{
		PrintFatalError("DirectDraw: Error setting cooperative level.");
		return 0;
	}
	
	switch(vmode)
	{
	default:
	case 1: MainWindowX=320;MainWindowY=240;ddrval = IDirectDraw4_SetDisplayMode ( lpDD4, 320, 240, 8,0,0);break;
	case 2: MainWindowX=512;MainWindowY=384;ddrval = IDirectDraw4_SetDisplayMode ( lpDD4, 512, 384, 8,0,0);break;
	case 3:
	case 4:
	case 5:
	case 6: MainWindowX=640;
		MainWindowY=480;
		ddrval = IDirectDraw4_SetDisplayMode ( lpDD4, 640, 480, 8,0,0);break;
	case 7: MainWindowX=1024;
		MainWindowY=768;
		ddrval = IDirectDraw4_SetDisplayMode ( lpDD4, 1024, 768, 8,0,0);break;
	case 8: MainWindowX=1280;
		MainWindowY=1024;
		ddrval = IDirectDraw4_SetDisplayMode ( lpDD4, 1280, 1024, 8,0,0);break;
	case 9: MainWindowX=1600;
		MainWindowY=1200;
		ddrval = IDirectDraw4_SetDisplayMode ( lpDD4, 1600, 1200, 8,0,0);break;
	}
	
	if (ddrval != DD_OK)
	{
		PrintFatalError("DirectDraw: Error setting display mode.");
		return 0;
	}
	
	caps.dwSize=sizeof(caps);
	if(IDirectDraw4_GetCaps(lpDD4,&caps,0)==DD_OK)
	{
		if(vmode>=6)
		{
			if(caps.dwCaps&DDCAPS_BLTSTRETCH)   
				vflags|=1;
			else if(vmode==6)
				goto nostretch;
			
			memset(&ddsdback,0,sizeof(ddsdback));
			ddsdback.dwSize=sizeof(ddsdback);
			ddsdback.dwFlags = DDSD_CAPS | DDSD_HEIGHT | DDSD_WIDTH; 
			ddsdback.ddsCaps.dwCaps= DDSCAPS_LOCALVIDMEM | DDSCAPS_OFFSCREENPLAIN | DDSCAPS_VIDEOMEMORY;
			
			if(vmode==7 || vmode==8)
				ddsdback.dwHeight=256;
			else
				ddsdback.dwHeight=240;
			
			if(vmode>=7)
				ddsdback.dwWidth=256;
			else
				ddsdback.dwWidth=320;
			
			ddrval = IDirectDraw4_CreateSurface ( lpDD4, &ddsdback, &lpDDSBack, (IUnknown FAR*)NULL);
			if(ddrval!=DD_OK) vflags&=~1;
		}
	}
nostretch:
	
	// create foreground surface
	memset(&ddsd,0,sizeof(ddsd));
	ddsd.dwSize = sizeof(ddsd);
	ddsd.dwFlags = DDSD_CAPS | DDSD_BACKBUFFERCOUNT;
	ddsd.ddsCaps.dwCaps = DDSCAPS_VIDEOMEMORY | DDSCAPS_PRIMARYSURFACE | DDSCAPS_FLIP | DDSCAPS_COMPLEX;  
	ddsd.dwBackBufferCount = 1;
	
	ddrval = IDirectDraw4_CreateSurface ( lpDD4, &ddsd, &lpDDSPrimary, (IUnknown FAR*)NULL);
	if (ddrval != DD_OK)
	{
		ResetVideo();
		PrintFatalError("DirectDraw: Error creating primary surface.");
		return 0;
	}
	
	vmod=vmode;
	// Set palette stuff
	memset(&lpddpal,0x00,sizeof(lpddpal));
	
	
	ddrval=IDirectDraw4_CreatePalette( lpDD4, DDPCAPS_8BIT|DDPCAPS_ALLOW256|DDPCAPS_INITIALIZE,color_palette,&lpddpal,NULL);
	if (ddrval != DD_OK)
	{
		ResetVideo();
		PrintFatalError("DirectDraw: Error creating palette object.");
		return 0;
	}
	
	ddrval=IDirectDrawSurface4_SetPalette(lpDDSPrimary, lpddpal);
	if (ddrval != DD_OK)
	{
		ResetVideo();
		PrintFatalError("DirectDraw: Error setting palette object.");
		return 0;
	}
	ShowMainWindow();
	ShowCursor(0);
	veflags|=1;
	return 1;
}

byte vretrace=1;
static long ZK;
static long ZL;
void WaitForVBlank(void)
{
	if(ssync && soundon)
	{
wackyer:
    if(vretrace)
    {
		vretrace--;
    }
    else
    {
		if(BlockingCheck()) return;
		Sleep(0);
		goto wackyer;
    }
	}
	else if(!ssync)
		IDirectDraw_WaitForVerticalBlank(lpDD,DDWAITVB_BLOCKBEGIN,0);
}


void ResetVideo(void)
{
	if(lpDD4) IDirectDraw4_RestoreDisplayMode(lpDD4);
	lpDD4=0;
}


LPDIRECTINPUTDEVICE lpdid=0;

int KeyboardInitialize(void)
{
	
	ddrval=IDirectInput_CreateDevice(lpDI, &GUID_SysKeyboard,&lpdid,0);
	if(ddrval != DI_OK)
	{
		ResetVideo();
		PrintFatalError("DirectInput: Error creating keyboard device.");
		return 0;
	}
	
	ddrval=IDirectInputDevice_SetCooperativeLevel(lpdid, hAppWnd, DISCL_BACKGROUND|DISCL_NONEXCLUSIVE/*DISCL_FOREGROUND|DISCL_NONEXCLUSIVE*/);
	if(ddrval != DI_OK)
	{
		ResetVideo();
		PrintFatalError("DirectInput: Error setting keyboard cooperative level.");
		return 0;
	}
	
	
	ddrval=IDirectInputDevice_SetDataFormat(lpdid,&c_dfDIKeyboard);
	if(ddrval != DI_OK)
	{
		ResetVideo();
		PrintFatalError("DirectInput: Error setting keyboard data format.");
		return 0;
	}
	
	ddrval=IDirectInputDevice_Acquire(lpdid);
	if(ddrval != DI_OK)
	{
		ResetVideo();
		PrintFatalError("DirectInput: Error acquiring keyboard.");
		return 0;
	}
	return 1;
}

void KeyboardClose(void)
{
	if(lpdid) IDirectInputDevice_Unacquire(lpdid);
	lpdid=0;
}

int KeyboardUpdate(void){return 1;}

char buf[256];
char *KeyboardGetstate(void)
{
	ddrval=IDirectInputDevice_GetDeviceState(lpdid,256,buf);
	switch(ddrval)
	{
	case DIERR_INPUTLOST:
	case DIERR_NOTACQUIRED:
		IDirectInputDevice_Acquire(lpdid);
		break;
	}
	return buf;
}



static int joycounter;
LPDIRECTINPUTDEVICE2 lpJoy[4];
int JoyXCenter[4],JoyYCenter[4];

DIJOYSTATE JoyStatus;

unsigned long GetJSOr(void)
{
	unsigned long ret;
	int x;
	ret=0;
	
	for(x=0;x<4;x++)
	{
		if(joy[x])
		{
			IDirectInputDevice2_Poll(lpJoy[x]);
			ddrval=IDirectInputDevice2_GetDeviceState(lpJoy[x],sizeof(JoyStatus),&JoyStatus);
			switch(ddrval)
			{
			case DIERR_INPUTLOST:
			case DIERR_NOTACQUIRED:
				IDirectInputDevice2_Acquire(lpJoy[x]);
				break;
			}
			if(JoyStatus.lX>=JoyXCenter[x]+(JoyXCenter[x]>>1))
				ret|=JOY_RIGHT<<(x<<3);
			else if(JoyStatus.lX<=JoyXCenter[x]>>1)
				ret|=JOY_LEFT<<(x<<3);
			
			if(JoyStatus.lY>=JoyYCenter[x]+(JoyYCenter[x]>>1))
				ret|=JOY_DOWN<<(x<<3);
			else if(JoyStatus.lY<=JoyYCenter[x]>>1)
				ret|=JOY_UP<<(x<<3);
			
			if(JoyStatus.rgbButtons[1]&0x80) ret|=1<<(x<<3);
			if(JoyStatus.rgbButtons[0]&0x80) ret|=2<<(x<<3);
			if(JoyStatus.rgbButtons[2]&0x80) ret|=4<<(x<<3);
			if(JoyStatus.rgbButtons[3]&0x80) ret|=8<<(x<<3);
		}
	}
	return ret;
}
void KillJoystick(void){}

HRESULT IDirectInput_CreateDevice2(LPDIRECTINPUT pdi, 
                                   REFGUID rguid, 
                                   LPDIRECTINPUTDEVICE2 *ppdev2, 
                                   LPUNKNOWN punkOuter) 
{ 
    LPDIRECTINPUTDEVICE pdev; 
    HRESULT hres; 
	
    hres = IDirectInput_CreateDevice(pdi, rguid, &pdev, punkOuter);
	
    if (SUCCEEDED(hres)) { 
		hres = pdev->lpVtbl->QueryInterface(pdev, 
			&IID_IDirectInputDevice2, 
			(LPVOID *)ppdev2); 
		IDirectInputDevice_Release(pdev); 
    } else { 
		*ppdev2 = 0; 
    } 
    return hres; 
} 

BOOL CALLBACK JoystickFound(LPCDIDEVICEINSTANCE lpddi, LPVOID pvRef)
{
	int x;
	printf(" Found %s...",lpddi->tszProductName);
	for(x=0;x<4;x++)
		if(joy[x]==joycounter)
		{printf(" Used as virtual joystick %d.\n",x+1);joyF[x]=1;joyGUID[x]=lpddi->guidInstance;}
		return DIENUM_CONTINUE;
}


char InitJoystick(void)
{
	int x;
	for(x=0;x<4;x++) joyF[x]=0;
	joycounter=1;
	puts("Enumerating joysticks...");
	IDirectInput_EnumDevices(lpDI, DIDEVTYPE_JOYSTICK,JoystickFound,0,DIEDFL_ATTACHEDONLY);
	for(x=0;x<4;x++) 
		if(!joyF[x]) joy[x]=0;
		HideMainWindow();
		for(x=0;x<4;x++)
		{
			if(!joy[x]) continue;
			
			ddrval=IDirectInput_CreateDevice2(lpDI, &joyGUID[x],&lpJoy[x],0);
			if (ddrval != DI_OK)
			{
				printNonFatal("DirectInput: Error creating DirectInput joystick device.");
				joy[x]=0;
				continue;
			}
			
			ddrval=IDirectInputDevice2_SetCooperativeLevel(lpJoy[x], hAppWnd, /*DISCL_FOREGROUND|DISCL_NONEXCLUSIVE*/DISCL_BACKGROUND|DISCL_NONEXCLUSIVE);
			if (ddrval != DI_OK)
			{
				printNonFatal("DirectInput: Error creating DirectInput joystick cooperative level.");
				joy[x]=0;
				continue;
			}
			
			ddrval=IDirectInputDevice2_SetDataFormat(lpJoy[x],&c_dfDIJoystick);
			if (ddrval != DI_OK)
			{
				printNonFatal("DirectInput: Error creating DirectInput joystick data format.");
				joy[x]=0;
				continue;
			}
			
			ddrval=IDirectInputDevice2_Acquire(lpJoy[x]);
			if (ddrval != DI_OK)
			{
				printNonFatal("DirectInput: Error acquiring DirectInput joystick.");
				joy[x]=0;
				continue;
			}
			
			IDirectInputDevice2_Poll(lpJoy[x]);
			ddrval=IDirectInputDevice2_GetDeviceState(lpJoy[x],sizeof(JoyStatus),&JoyStatus);
			if (ddrval != DI_OK)
			{
				printNonFatal("DirectInput: Error getting DirectInput joystick state.");
				joy[x]=0;
				continue;
			}
			
			JoyXCenter[x]=JoyStatus.lX;
			JoyYCenter[x]=JoyStatus.lY;
		}
		
		return 0;
}



LPDIRECTSOUND ppDS;
LPDIRECTSOUNDBUFFER ppbuf;


DSBUFFERDESC DSBufferDesc;
WAVEFORMATEX wf;


static int DSBufferSize=0;


int MakeDSThread(void);
int InitSound()
{
	DSBCAPS dsbcaps;
	int rate;
	
	rate=44100;
	
	memset(&DSBufferDesc,0x00,sizeof(DSBufferDesc));
	DSBufferDesc.dwSize=sizeof(DSBufferDesc);
	DSBufferDesc.dwFlags=DSBCAPS_GETCURRENTPOSITION2|DSBCAPS_PRIMARYBUFFER;
	
	memset(&wf,0x00,sizeof(wf));
	wf.wFormatTag = WAVE_FORMAT_PCM;
	wf.nChannels = 1;
	wf.nSamplesPerSec = rate;
	wf.wBitsPerSample=8;
	wf.nBlockAlign = 1;
	wf.nAvgBytesPerSec = wf.nSamplesPerSec * wf.nBlockAlign;
	
	
	ddrval=DirectSoundCreate(0,&ppDS,0);
	if (ddrval != DS_OK)
	{
		printNonFatal("DirectSound: Error creating DirectSound object.");
		return 0;
	}
	
	ShowMainWindow();
	ddrval=IDirectSound_SetCooperativeLevel(ppDS,hAppWnd,DSSCL_WRITEPRIMARY);
	if (ddrval != DS_OK)
	{
		printNonFatal("DirectSound: Error setting cooperative level.");
		return 0;
	}
	HideMainWindow();
	
	ddrval=IDirectSound_CreateSoundBuffer(ppDS,&DSBufferDesc,&ppbuf,0);
	if (ddrval != DS_OK)
	{
		printNonFatal("DirectSound: Error creating buffer.");
		return 0;
	}
	
	memset(&dsbcaps,0,sizeof(dsbcaps));
	dsbcaps.dwSize=sizeof(dsbcaps);
	ddrval=IDirectSoundBuffer_GetCaps(ppbuf,&dsbcaps);
	if (ddrval != DS_OK)
	{
		printNonFatal("DirectSound: Error getting buffer capabilities.");
		return 0;
	}
	
	DSBufferSize=dsbcaps.dwBufferBytes;
	
	ddrval=IDirectSoundBuffer_SetFormat(ppbuf,&wf);
	if (ddrval != DS_OK)
	{
		printNonFatal("DirectSound: Error setting primary buffer format.");
		return 0;
	}
	
	if(!MakeDSThread())
	{
		printNonFatal("DirectSound: Error creating sound thread.");
		return 0;
	}
	
	ZK=((unsigned long)0x2000000*(PAL?50:60)/(rate/256));
	ZL=0;
	
	return rate;
}

static SECURITY_ATTRIBUTES secatr;
static DWORD threadid;

static int SoundExit=0;
int DSThread(void)
{
	static char *feegle;
	static DWORD dook;
	static DWORD currentpos=0,lastpos=0;
	
	IDirectSoundBuffer_Play(ppbuf,0,0,DSBPLAY_LOOPING);
	
	while(!SoundExit)
	{
		ddrval=IDirectSoundBuffer_GetCurrentPosition(ppbuf,&currentpos,0);
		if(ddrval!=DD_OK)
		{
			if(ddrval==DSERR_BUFFERLOST)
				IDirectSoundBuffer_Restore(ppbuf);
			IDirectSoundBuffer_SetFormat(ppbuf,&wf);
			IDirectSoundBuffer_Play(ppbuf,0,0,DSBPLAY_LOOPING);
			goto slopalop;
		}
		
		currentpos&=~255;
		currentpos+=1024;
		currentpos&=(DSBufferSize-1);
		if(currentpos!=lastpos)
		{
dolt:
		dook=256;
		lastpos+=256;
		lastpos&=(DSBufferSize-1);
		ddrval=IDirectSoundBuffer_Lock(ppbuf,lastpos,dook,(LPVOID *)&feegle,&dook,0,0,0);
		if(ddrval!=DD_OK)
		{
			if(ddrval==DSERR_BUFFERLOST)
				IDirectSoundBuffer_Restore(ppbuf);
			IDirectSoundBuffer_SetFormat(ppbuf,&wf);
			IDirectSoundBuffer_Play(ppbuf,0,0,DSBPLAY_LOOPING);
		}
		else
		{
			FillSoundBuffer(feegle);
			IDirectSoundBuffer_Unlock(ppbuf,&feegle,dook,0,0);
			if(ssync)
			{
				ZL+=ZK;
				if(ZL>=0x2000000)
				{
					ZL-=0x2000000;
					if(vretrace<4) vretrace++;
				}
			}
			if(currentpos==lastpos) Sleep(4);
		}
		}
		if(currentpos!=lastpos) goto dolt;
slopalop:
	}
	IDirectSoundBuffer_Stop(ppbuf);
	ExitThread(0);
}

int MakeDSThread(void)
{
	memset(&secatr,0,sizeof(secatr));
	secatr.nLength=sizeof(secatr);
	secatr.bInheritHandle=1;  
	ThreadHandle=CreateThread(&secatr,4096,(void *)DSThread,0,0,&threadid);
	if(!ThreadHandle) return 0;
	
	SetThreadPriority(ThreadHandle,THREAD_PRIORITY_ABOVE_NORMAL);
	return 1;
}

void TrashSound()
{
	SoundExit=1;
}

#include "netplay.c"

